config/routes.rb
Rails.application.routes.draw do
  get 'transactions/top_up'
  post 'transactions/do_top_up'
  get 'transactions/peer_transfer'
  post 'transactions/do_peer_transfer'
  get 'transactions/team_share'
  post 'transactions/do_team_share'
  get 'transactions/stock_invest'
  post 'transactions/do_stock_invest'
  get 'transactions/withdraw_team_share'
  post 'transactions/do_withdraw_team_share'
  get 'transactions/withdraw_stock_invest'
  post 'transactions/do_withdraw_stock_invest'
  get "wallet/show"

  resources :wallet
  resources :stocks
  resources :teams
  resources :users
  root 'users#index'
end

app/models/stock.rb
class Stock < ApplicationRecord
  include Walletable
  
  has_one :wallet, :as => :owner
  has_many :portfolios
  has_many :users, :through => :portfolios, :source => :investor, :source_type => "User"
  has_many :teams, :through => :portfolios, :source => :investor, :source_type => "Team"

  validates :name, presence: true
end

app/controllers/stocks_controller.rb
class StocksController < ApplicationController
  before_action :set_stock, only: %i[ show edit update destroy ]

  # GET /stocks or /stocks.json
  def index
    @stocks = Stock.all.order(:name)
  end

  # GET /stocks/1 or /stocks/1.json
  def show
  end

  # GET /stocks/new
  def new
    @stock = Stock.new
  end

  # GET /stocks/1/edit
  def edit
  end

  # POST /stocks or /stocks.json
  def create
    @stock = Stock.new(stock_params)

    respond_to do |format|
      if @stock.save
        format.html { redirect_to @stock, notice: "Stock was successfully created." }
        format.json { render :show, status: :created, location: @stock }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @stock.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /stocks/1 or /stocks/1.json
  def update
    respond_to do |format|
      if @stock.update(stock_params)
        format.html { redirect_to @stock, notice: "Stock was successfully updated." }
        format.json { render :show, status: :ok, location: @stock }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @stock.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /stocks/1 or /stocks/1.json
  def destroy
    @stock.destroy
    respond_to do |format|
      format.html { redirect_to stocks_url, notice: "Stock was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_stock
      @stock = Stock.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def stock_params
      params.require(:stock).permit(:name)
    end
end

app/helpers/stocks_helper.rb
module StocksHelper
end

app/views/stocks/_form.html.erb
<%= form_with(model: stock) do |form| %>
  <%= render 'shared/form_error', model: stock %>
  <div class="mb-3">
    <%= form.label :name, nil, class: "form-label" %>
    <%= form.text_field :name, class: "form-control" %>
  </div>

  <div class="actions">
    <%= form.submit class: "btn btn-primary" %>
  </div>
<% end %>

app/views/stocks/edit.html.erb
<h1>Editing Stock</h1>

<%= render 'form', stock: @stock %>

<br />

<div>
    <%= link_to stocks_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
    <%= link_to @stock, class: "btn btn-success" do %>
        <i class="fas fa-search"></i>
        Show
    <% end %>
</div>

app/views/stocks/index.html.erb
<div class="d-flex justify-content-between align-items-center">
    <div class="p-2">
      <h1>Stocks</h1>
    </div>
    <div class="p-2">
      <%= link_to new_stock_path, class: "btn btn-primary" do %>
        <i class="fas fa-plus-circle"></i>
        New Stock
      <% end %>
    </div>
</div>

<table class="table table-striped">
  <thead>
    <tr>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @stocks.each do |stock| %>
      <tr>
        <td><%= stock.name %></td>
        <td>
          <div class="">
            <%= link_to stock, class: "btn btn-success" do %>
              <i class="fas fa-search"></i>
              Show
            <% end %>
            <%= link_to edit_stock_path(stock), class: "btn btn-warning" do %>
              <i class="fas fa-edit"></i>
              Edit
            <% end %>
            <%= link_to stock, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-danger" do %>
              <i class="fas fa-trash"></i>
              Delete
            <% end %>
          </div>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/stocks/new.html.erb
<h1>New Stock</h1>

<%= render 'form', stock: @stock %>

<br />

<div>
    <%= link_to stocks_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
</div>

app/views/stocks/show.html.erb
<table class="table table-striped">
    <thead>
        <tr>
            <th colspan="2">
                <h2><%= @stock.name %></h2>
            </th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>Balance</td>
            <td>
                <div class="d-flex justify-content-between align-items-center">
                    <div class="p-2 fw-bold">
                        Rp <%= format_amount @stock.wallet.get_balance %>
                    </div>
                    <div class="p-2">
                        <%= link_to(wallet_path(@stock.wallet), class: 'btn btn-primary') do %>
                            <i class="fas fa-wallet nav-icon"></i>
                            Open Wallet
                        <% end %>
                    </div>
                </div>
            </td>
        </tr>
        <tr>
            <td>Individual Investors</td>
            <td>
                <ul class="list-group list-group-flush">
                    <% @stock.users.each do |i| %>
                    <li class="list-group-item d-flex justify-content-between align-items-start bg-transparent">
                        <div class="ms-2 me-auto">
                            <div class="fw-bold"><%= i.name %></div>
                            (Rp <%= format_amount i.getStockShareBalance(@stock) %>)
                        </div>
                    </li>
                    <% end %>
                </ul>
            </td>
        </tr>
        <tr>
            <td>Team Investors</td>
            <td>
                <ul class="list-group list-group-flush">
                    <% @stock.teams.each do |i| %>
                    <li class="list-group-item d-flex justify-content-between align-items-start bg-transparent">
                        <div class="ms-2 me-auto">
                            <div class="fw-bold"><%= i.name %></div>
                            (Rp <%= format_amount i.getStockShareBalance(@stock) %>)
                        </div>
                    </li>
                    <% end %>
                </ul>
            </td>
        </tr>
    </tbody>
</table>

<div>
    <%= link_to stocks_path, class: "btn btn-secondary" do %>
        <i class="fas fa-arrow-circle-left"></i>
        Back
    <% end %>
    <%= link_to edit_stock_path(@stock), class: "btn btn-warning" do %>
        <i class="fas fa-edit"></i>
        Edit
    <% end %>
</div>